module statistics
  use iso_c_binding
  implicit none
  integer, parameter :: myk = kind(1.d0)

  interface
    function init_c(n,a) bind(c,name='init')
       use iso_c_binding
       implicit none
       integer(c_int) :: init_c
       integer(c_int), value :: n
       real(c_double) :: a(n)
    end function init_c
    function avg_var_fun_c(n,a,var) bind(c,name='avg_var_fun')
       use iso_c_binding
       implicit none
       integer(c_int) :: avg_var_fun_c
       integer(c_int), value :: n
       real(c_double) :: a(n), var
    end function avg_var_fun_c
  end interface

contains
  subroutine init(a)
      real(kind(1.d0)) :: a(:)
      integer :: i,n
      n = size(a)
      i = init_c(n,a)
  end subroutine init
  function avg_var_fun(a,var)
      real(myk) :: a(:), var
      integer :: i,n
      real(myk) :: avg_var_fun
      n = size(a)
      i = avg_var_fun_c(n,a,var)
  end function avg_var_fun
end module statistics
